<template>
  <v-card flat elevation="1">
    <v-container>
      <tabs :tabs="tabs">
        <template v-slot:Detaje>
          <create-client-form v-model="form" />
        </template>
        <template v-slot:Adresat>
          <client-addresses :client-id="clientId" v-model="request.addresses" />
        </template>
        <template v-slot:Kontaktet>
          <client-contacts :client-id="clientId" v-model="request.contacts" />
        </template>
      </tabs>
    </v-container>
    <v-row class="mr-5 pb-5">
      <v-spacer />
      <f-cancel-btn @click="$emit('close-form')" />
      <f-submit-btn @click="submit" :loading="loading" :disabled="loading" />
    </v-row>
    <toast :snackbar="show" :type="color" :message="message" />
    <portal to="destination">
      <div class="portal-wrapper">
        <h3>
          <f-back-btn back :route="backRoute" />
          Klientet |
          <p class="faded">
            Modifikimi i Klientit
          </p>
        </h3>
      </div>
    </portal>
  </v-card>
</template>
<script lang="ts">
import Vue from 'vue'
import { Component, Prop } from 'vue-property-decorator'
import eventBus from '../../../plugins/event-bus'
import Tabs from '../../../components/tabs/Tabs.vue'
import CreateClientForm from './CreateClientForm.vue'
import ClientContacts from './ClientContacts.vue'
import ClientAddresses from './ClientAddresses.vue'
import FCancelBtn from '../../../components/buttons/FCancelBtn.vue'
import FBackBtn from '../../../components/buttons/FBackBtn.vue'
import FSubmitBtn from '../../../components/buttons/FSubmitBtn.vue'
import Toast from '../../../components/toasts/Toast.vue'
import api from '@/plugins/api'

const tabs = [{ tab: 'Detaje' }, { tab: 'Adresat' }, { tab: 'Kontaktet' }]

const form = {
  industry_type_id: '',
  business_type_id: '',
  nuis: '',
  name: '',
  owner: '',
  email: '',
  contact_name: '',
  phone: '',
  mobile_phone: '',
  zone: '',
  city_id: '',
  website: '',
  notes: '',
  payment_term_id: '',
  is_with_vat: true,
  is_with_monthly_payments: true,
  only_einvoice: false,
  points: 0,
}

const request = {
  addresses: [],
  contacts: [],
}
@Component({
  components: {
    Tabs,
    Toast,
    ClientContacts,
    CreateClientForm,
    ClientAddresses,
    FCancelBtn,
    FBackBtn,
    FSubmitBtn,
  },
})
export default class EditClientForm extends Vue {
  @Prop({ type: Number, required: true }) clientId
  tabs = tabs
  message = ''
  show = false
  color = ''
  addressId = 1
  contactId = 1
  address = ''
  zip_code = ''
  city = ''
  country = ''
  name = ''
  email = ''
  phone_number = ''
  job_position = ''
  loading = false
  addresses = []
  contacts = []
  form = form
  request = request
  backRoute = 'Clients'

  mounted() {
    console.log('tabs', this.tabs)
    this.fetchClient()
    this.clear()
  }
  clear() {
    eventBus.$on('clear-inputs', () => {
      this.clearInputs()
    })
  }
  clearInputs() {
    this.form.industry_type_id = ''
    this.form.business_type_id = ''
    this.form.nuis = ''
    this.form.name = ''
    this.form.owner = ''
    this.form.email = ''
    this.form.contact_name = ''
    this.form.phone = ''
    this.form.mobile_phone = ''
    this.form.zone = ''
    this.form.city_id = ''
    this.form.website = ''
    this.form.notes = ''
    this.form.payment_term_id = ''
    this.form.is_with_vat = true
    this.form.is_with_monthly_payments = true
    this.form.only_einvoice = false
    this.form.points = 0
    this.request.addresses = []
    this.request.contacts = []
  }
  submit() {
    this.loading = true
    const payload = { ...this.form, ...this.request }
    api()
      .put(`api/crm/clients/${this.clientId}`, payload)
      .then(response => {
        alert(response.data.message)

        this.show = true
        this.message = response.data.message

        if (response && response.data.data && response.data.status === 0) {
          this.color = 'success'
          this.$emit('close-form')
        } else {
          this.color = 'error'
        }
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }
  fetchClient() {
    api()
      .get(`api/crm/clients/${this.clientId}`)
      .then(response => {
        const result = response.data.data[0]
        this.form = result
        this.request = result
      })
  }
}
</script>
<style scoped>
.faded {
  display: inline;
  color: gray;
}
</style>
